#include "registry.hpp"
#include "http_easy.hpp"
#include "ftp_easy.hpp"

namespace curlpp
{
   namespace registries
   {
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::url
      >
      url;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::verbose
      >
      verbose;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::header
      >
      header;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::signal
      >
      signal;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::progress
      >
      progress;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::fail_on_error
      >
      fail_on_error;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::dns_cache_timeout
      >
      dns_cache_timeout;
      
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::dns_use_global_cache
      >
      dns_use_global_cache;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::buffersize
      >
      buffersize;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::proxy_name
      >
      proxy_name;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::proxy_port
      >
      proxy_port;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::proxy_type::type ),
      &curlpp::easy::proxy_type
      >
      proxy_type;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::http_proxy_tunnel
      >
      http_proxy_tunnel;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::interface
      >
      interface;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::infile_size
      >
      infile_size;
 
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::netrc::type ),
      &curlpp::easy::netrc
      >
      netrc;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::encoding
      >
      encoding;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( bool ),
      &curlpp::http_easy::follow_location
      >
      follow_location;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( long ),
      &curlpp::http_easy::max_redir
      >
      max_redir;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( bool ),
      &curlpp::http_easy::put
      >
      put;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::post_fields
      >
      post_fields;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::referer
      >
      referer;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::user_agent
      >
      user_agent;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::list< std::string > & ),
      &curlpp::http_easy::http_header
      >
      http_header;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::cookie
      >
      cookie;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::cookie_file
      >
      cookie_file;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const std::string & ),
      &curlpp::http_easy::cookie_jar
      >
      cookie_jar;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( curlpp::time_condition::type ),
      &curlpp::http_easy::time_condition
      >
      time_condition;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( long ),
      &curlpp::http_easy::time_value
      >
      time_value;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( bool ),
      &curlpp::http_easy::http_get
      >
      http_get;

      typedef curlpp::registry
      <
      void( curlpp::http_easy::* ) ( const curlpp::http_version::type ),
      &curlpp::http_easy::http_version
      >
      http_version;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( const std::string &),
      &curlpp::ftp_easy::ftp_port
      >
      ftp_port;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( const std::list< std::string > &),
      &curlpp::ftp_easy::quote
      >
      quote;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( const std::list< std::string > &),
      &curlpp::ftp_easy::post_quote
      >
      post_quote;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( const std::list< std::string > &),
      &curlpp::ftp_easy::pre_quote
      >
      pre_quote;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( bool ),
      &curlpp::ftp_easy::ftp_list_only
      >
      ftp_list_only;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( bool ),
      &curlpp::ftp_easy::ftp_append
      >
      ftp_append;

      typedef curlpp::registry
      <
      void( curlpp::ftp_easy::* ) ( bool ),
      &curlpp::ftp_easy::ftp_use_epsv
      >
      ftp_use_epsv;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::transfert_text
      >
      transfert_text;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::crlf
      >
      crlf;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::range
      >
      range;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::resume_from
      >
      resume_from;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::custom_request
      >
      custom_request;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::file_time
      >
      file_time;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::no_body
      >
      no_body;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::upload
      >
      upload;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::timeout
      >
      timeout;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::low_speed_limit
      >
      low_speed_limit;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::low_speed_time
      >
      low_speed_time;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::max_connects
      >
      max_connects;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::close_policy::type ),
      &curlpp::easy::close_policy
      >
      close_policy;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::fresh_connect
      >
      fresh_connect;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::forbid_reuse
      >
      forbid_reuse;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( long ),
      &curlpp::easy::connect_timeout
      >
      connect_timeout;
     
      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ssl_cert
      >
      ssl_cert;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::ssl_cert_type::type ),
      &curlpp::easy::ssl_cert_type
      >
      ssl_cert_type;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ssl_key
      >
      ssl_key;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::ssl_key_type::type ),
      &curlpp::easy::ssl_key_type
      >
      ssl_key_type;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ssl_key_passwd
      >
      ssl_key_passwd;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ssl_engine
      >
      ssl_engine;

      typedef curlpp::registry_free
      <
      void( curlpp::easy::* ) (),
      &curlpp::easy::ssl_engine_default
      >
      ssl_engine_default;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::ssl_version::type ),
      &curlpp::easy::ssl_version
      >
      ssl_version;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( bool ),
      &curlpp::easy::ssl_verify_peer
      >
      ssl_verify_peer;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ca_info
      >
      ca_info;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::ca_path
      >
      ca_path;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::random_file
      >
      random_file;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::string & ),
      &curlpp::easy::egd_socket
      >
      egd_socket;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::ssl_verify_host::type ),
      &curlpp::easy::ssl_verify_host
      >
      ssl_verify_host;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( const std::list< std::string > & ),
      &curlpp::easy::ssl_cipher_list
      >
      ssl_cipher_list;

      typedef curlpp::registry
      <
      void( curlpp::easy::* ) ( curlpp::krb4_level::type ),
      &curlpp::easy::krb4_level
      >
      krb4_level;
   }
}


